//+------------------------------------------------------------------+
//|                                                    Guppy MMA.mq5 |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "wwww.forex-tsd.com"


#property indicator_chart_window
#property indicator_buffers 12
#property indicator_plots   12

//
//
//
//
//

input ENUM_APPLIED_PRICE Price     = PRICE_CLOSE;     // Guppy MMAs price
input ENUM_MA_METHOD     Method    = MODE_EMA;        // Guppy MMAs method
input color              ColorFrom = LimeGreen;       // Starting color for MAs
input color              ColorTo   = PaleVioletRed;   // Ending color for MAs

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

struct simpleMa { int handle; double buffer[]; };
       simpleMa aBuffers[12];
int steps;

//
//
//
//
//

int OnInit()
{
   int periods[] = {3,5,8,10,12,15,30,35,40,45,50,60};
       steps     = ArraySize(periods);

       //
       //
       //
       //
       //
       
       for (int i=0;i<steps; i++)
       {
         int handle = iMA(NULL,0,periods[i],0,Method,Price);
            aBuffers[i].handle = handle;
            SetIndexBuffer(i,aBuffers[i].buffer,INDICATOR_DATA);
            PlotIndexSetInteger(i,PLOT_DRAW_TYPE ,DRAW_LINE);
            PlotIndexSetInteger(i,PLOT_COLOR_INDEXES,1);
            PlotIndexSetInteger(i,PLOT_LINE_COLOR,gradientColor(i,steps,ColorFrom,ColorTo));
            PlotIndexSetString(i,PLOT_LABEL,"Guppy MA "+IntegerToString(periods[i]));
       }

   IndicatorSetString(INDICATOR_SHORTNAME,"Guppy MMA");
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime& time[],
                const double& open[],
                const double& high[],
                const double& low[],
                const double& close[],
                const long& tick_volume[],
                const long& volume[],
                const int& spread[])
{
   int limit = rates_total-prev_calculated; if (prev_calculated > 0) limit++;
            for (int i=0; i<steps; i++) 
                     CopyBuffer(aBuffers[i].handle,0,0,limit,aBuffers[i].buffer);
   return(rates_total);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

color gradientColor(int step, int totalSteps, color from, color to)
{
   color newBlue  = getColor(step,totalSteps,(from & 0XFF0000)>>16,(to & 0XFF0000)>>16)<<16;
   color newGreen = getColor(step,totalSteps,(from & 0X00FF00)>> 8,(to & 0X00FF00)>> 8) <<8;
   color newRed   = getColor(step,totalSteps,(from & 0X0000FF)    ,(to & 0X0000FF)    )    ;
   return(newBlue+newGreen+newRed);
}
color getColor(int stepNo, int totalSteps, color from, color to)
{
   double step = (from-to)/(totalSteps-1.0);
   return((color)round(from-step*stepNo));
}